=== package/debian/changelog ===
corrade (2020.06) unstable; urgency=low

  * Version 2020.06

 -- Vladimír Vondruš <mosra@centrum.cz>  Fri, 26 Jun 2020 20:54:25 +0200

corrade (2019.10) unstable; urgency=low

  * Version 2019.10

 -- Vladimír Vondruš <mosra@centrum.cz>  Thu, 24 Oct 2019 13:13:50 +0200

corrade (2019.01) unstable; urgency=low

  * Version 2019.01

 -- Vladimír Vondruš <mosra@centrum.cz>  Mon, 04 Feb 2019 17:18:34 +0100

corrade (2018.10) unstable; urgency=low

  * Version 2018.10

 -- Vladimír Vondruš <mosra@centrum.cz>  Wed, 24 Oct 2018 15:49:30 +0200

corrade (2018.04) unstable; urgency=low

  * Version 2018.04

 -- Vladimír Vondruš <mosra@centrum.cz>  Tue, 01 May 2018 23:45:00 +0200

corrade (2018.02) unstable; urgency=low

  * Version 2018.02

 -- Vladimír Vondruš <mosra@centrum.cz>  Fri, 16 Feb 2018 00:21:35 +0100

corrade (2015.05) unstable; urgency=low

  * Version 2015.05

 -- Vladimír Vondruš <mosra@centrum.cz>  Sat, 09 May 2015 10:57:44 +0200

corrade (2014.06) unstable; urgency=low

  * Version 2014.06

 -- Vladimír Vondruš <mosra@centrum.cz>  Mon, 30 Jun 2014 00:10:06 +0200

corrade (2014.01) unstable; urgency=low

  * Version 2014.01

 -- Vladimír Vondruš <mosra@centrum.cz>  Tue, 21 Jan 2014 16:14:33 +0100

corrade (2013.10) unstable; urgency=low

  * Version 2013.10

 -- Vladimír Vondruš <mosra@centrum.cz>  Wed, 30 Oct 2013 18:24:06 +0100

corrade (2013.08) unstable; urgency=low

  * Version 2013.08

 -- Vladimír Vondruš <mosra@centrum.cz>  Wed, 30 Oct 2013 08:40:36 +0100

corrade (2012.02) unstable; urgency=low

  * Version 2012.02

 -- Vladimír Vondruš <mosra@centrum.cz>  Wed, 08 Feb 2012 01:28:01 +0100
